const std = @import("std");

pub fn build(b: *std.build.Builder) void {
    const target = b.standardTargetOptions(.{});
    const mode = std.builtin.Mode.ReleaseSafe;

    std.debug.assert(target.isWindows());

    const detours = b.addStaticLibrary("detours", null);
    detours.setTarget(target);
    detours.setBuildMode(mode);
    detours.linkLibC();
    detours.linkLibCpp();
    detours.force_pic = true;
    detours.install();
    detours.addIncludeDir("./Detours/src/");
    detours.addCSourceFiles(&.{
        "Detours/src/detours.cpp",
        "Detours/src/modules.cpp",
        "Detours/src/disasm.cpp",
        "Detours/src/image.cpp",
        "Detours/src/disolx86.cpp",
        "Detours/src/disolx64.cpp",
        "Detours/src/disolia64.cpp",
        "Detours/src/disolarm.cpp",
        "Detours/src/disolarm64.cpp",
        }, &.{"-Wall", "-DWIN32_LEAN_AND_MEAN", "-DDETOURS_VERSION=0x4c0c1", "-std=c++14"});
}
